This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 647972 - augtool uses 100% CPU when you hit tab key
augtool uses 100% CPU when you hit tab key
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: augeas (Show other bugs)
14
Unspecified Unspecified
low Severity medium
: ---
: ---
Assigned To: David Lutterkort
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-10-30 03:14 EDT by Richard W.M. Jones
Modified: 2013-04-30 19:42 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-16 15:00:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Richard W.M. Jones 2010-10-30 03:14:02 EDT
Description of problem:

augtool uses 100% CPU for about 30 seconds when you hit
the tab key at a certain point.

Version-Release number of selected component (if applicable):

augeas-0.7.3-1.fc14.x86_64

How reproducible:

Always.

Steps to Reproduce:
1. As root, run augtool
2. Type:  ls //fi
3. Hit the <tab> key.
  
Actual results:

augtool spins using 100% CPU for about 30 seconds.  Also
augtool is unresponsive during this time.

Expected results:

Should tab-complete the path or otherwise remain
responsive.

Additional info:
Comment 1 David Lutterkort 2011-01-12 15:29:54 EST
The problem is that hitting <TAB> there causes aug_match("//*",...) to be run to get possible completions.

Unfortunately, that path expression is extremely expensive to evaluate, and process for completion, since it matches every node in the tree, anywhere in the tree. And the autocompletion code needs to go through and check if the label starts with 'fi'.

Not sure how to fix this .. maybe not allow auto-completion of path expressions with '//' in them ? Or w
Comment 2 Richard W.M. Jones 2011-01-12 15:45:50 EST
I wonder if it's possible to estimate the cost of an expression
before evaluating it, and perhaps (in autocomplete) give up or
print a message.

I think I was confused when I filed the BZ, thinking that all
Augeas paths start with double // which of course they don't.
Comment 3 Fedora End Of Life 2012-08-16 15:00:24 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Note You need to log in before you can comment on or make changes to this bug.